import React from 'react';

export default class ListSortSettings extends React.PureComponent
{
    render()
    {
        return <div className={this.props.className} value={this.props.sort.sortby}>
            <select className="sortby">
                {['sent date', 'status', 'label', 'size', 'subject'].map((i) => (
                    <option key={'s'+i} value={i}>Sort by {i}</option>
                ))}
            </select>
            <select className="group" value={this.props.sort.group}>
                <option value="">Do not group</option>
                <option value="read">Group by read status</option>
                <option value="pinned">Group by pinned status</option>
                <option value="date">Group by date</option>
            </select>
            <label><input type="checkbox" checked={this.props.sort.ascending} /> Sort ascending</label>
            <label><input type="checkbox" checked={this.props.sort.threaded} /> Threaded</label>
        </div>
    }
}
