const webpack = require('webpack');
const path = require('path');

module.exports = {
  entry: {
    main: [ "babel-polyfill", './mail.js' ]
  },
  context: __dirname,
  output: {
    path: __dirname,
    filename: './mail.c.js'
  },
  devtool: 'cheap-module-source-map',
  module: {
    rules: [
      {
        test: /.jsx?$/,
        loader: 'babel-loader',
        exclude: /node_modules/
      },
      {
        test: /\.css$/,
        use: [
          {
            loader: "style-loader",
            options: {
              singleton: true
            }
          },
          {
            loader: "css-loader",
            options: {
              modules: true, // default is false
              sourceMap: true,
              importLoaders: 1,
              localIdentName: "[name]--[local]--[hash:base64:8]"
            }
          }
        ]
      }
    ]
  },
  plugins: [
    new webpack.DefinePlugin({
      "process.env": {
         NODE_ENV: JSON.stringify(process.env.NODE_ENV || "production")
       }
    })
  ],
  performance: {
    maxEntrypointSize: 5000000,
    maxAssetSize: 5000000
  }
};
